// ----------------------COMPOSANT HORLOGE---------------------------------------------------

unit Horloge;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Point, ExtCtrls, Graphics, Dialogue;

type TprocAlarme=procedure of object;

type
	TAiguille=class(TObject)
  // une aiguille d'horloge
	private
  	canvas:TCanvas;		// surface de dessin de l'aiguille (fournie par l'horloge)
		origine:TPoint;		// point d'accroche de l'aiguille
    extremite:TPointPolaire;	// ce point est modifi  chaque dplacement de l'aiguille
		longueur,epaisseur:integer;	// permet la distinction visuelle heure, minute et seconde
    couleur:TColor;		// couleur de dessin de l'aiguille
		procedure setPosition(p_position:double);
    	// p_position compris entre 0 et 60, double pour viter les "sauts"
		procedure dessiner(p_couleur:TColor);	// affichage ou effacement de l'aiguille selon la couleur
	public
  	constructor Create(p_canvas:TCanvas);overload;	// surcharge (signature diffrente)
    procedure init(p_origine:TPoint;p_longueur,p_epaisseur:integer;p_couleur:TColor);
    	// appele  l'initialisation de l'horloge
    destructor Destroy;override;	// redfinition (signature identique)
  end;

type
  THorloge=class(TGraphicControl)
  // composant graphique "horloge analogique"
  private
    { Dclarations prives }
    centre:TPoint;	// point d'accroche des aiguilles
    rayon:integer;	// rayon de l'horloge en pixels
    taille:integer;	// 1:petite, 2:moyenne, 3:grande (information calcule  l'initialisation)
    affDate:TPoint;	// position d'affichage de la date (taille 3 uniquement)
    FcouleurTrait,FcouleurFond:TColor;
    	// correspondent aux proprits publies couleurTrait et couleurFond
    heure,minute,seconde:TAiguille;	// les trois aiguilles de l'horloge
    temps:TTimer;		// dclencheur d'avancement
    alarme:boolean;	// vrai si l'alarme est programme
    momentAlarme:TDateTime;	// date et heure d'alarme
    libelleAlarme:string;	// libell li  l'alarme
    dialogue:Tfm_dialogue;
		FOnAlarme:TprocAlarme;	// procdure excute au dclenchement de l'alarme
		procedure init;	// appele au dbut, au redimensionnement, lors de la modification des couleurs
    procedure dessinerCadran;	// dessin du cadran de l'horloge
    procedure setCouleurTrait(p_couleur:TColor);virtual;	// appele en cas de modification de la proprit
    procedure setCouleurFond(p_couleur:TColor);virtual;	// idem
    procedure tempsTimer(sender : TObject);
    	// procdure dclenche chaque seconde
		procedure alarmeDefaut;	// alarme par dfaut
		procedure getMoment(var moment:TDateTime;var jour:string;var h,m,s:double);
    	// moment:date et heure systmes, jour:date formate, h,m,s:position des aiguilles selon l'heure
		procedure horlogeDblClick(sender : TObject);	// procdure vnementielle sur double-clic
  protected
    { Dclarations protges }
  public
    { Dclarations publiques }
    function getLibelle:string;	// retourne le libell de l'alarme
    constructor Create(AOwner:TComponent);override;	// constructeur redfini
    procedure Paint;override; // appele par le systme pour rafrachir l'affichage du composant
    destructor Destroy;override;	// destructeur redfini
  published
    { Dclarations publies }
		property CouleurTrait:TColor read FcouleurTrait write setCouleurTrait;  // accessible en conception
    property CouleurFond:TColor read FcouleurFond write setCouleurFond; // idem
    property OnAlarme:TprocAlarme read FOnAlarme write FOnAlarme;
    	// procdure appele lors du dclenchement de l'alarme
end;

procedure Register;

implementation

uses Math, DateUtils, Dialogs, Forms;

procedure Register;
// recensement du composant
begin
  RegisterComponents('Exemples', [THorloge]);
end;

// ----------------------METHODES DE TAiguille---------------------------------------------------

procedure TAiguille.setPosition(p_position : double);	// p_position compris entre 0 et 60
// positionnement de l'aiguille. canvas.brush.color est la couleur de fond:effacement de l'aiguille
begin
	dessiner(canvas.Brush.Color);
  extremite.setPosPolaireCentre(longueur,pi/30*(p_position-15),origine);
	dessiner(couleur);
end;

procedure TAiguille.dessiner(p_couleur : TColor);
// affichage ou effacement de l'aiguille selon la valeur de p_couleur
begin
	canvas.Pen.Width:=epaisseur;
	canvas.Pen.Color:=p_couleur;
	canvas.MoveTo(origine.getAbs,origine.getOrd);
  canvas.LineTo(extremite.getAbs,extremite.getOrd);
end;

constructor TAiguille.Create(p_canvas:TCanvas);
// le canevas de dessin est fourni par l'horloge
begin
	extremite:=TPointPolaire.Create;
	canvas:=p_canvas;
end;

procedure TAiguille.init(p_origine:TPoint;p_longueur,p_epaisseur:integer;p_couleur:TColor);
// initialisation d'une aiguille (au dbut ou aprs modification)
begin
	origine:=p_origine;
	longueur:=p_longueur;
  epaisseur:=p_epaisseur;
  couleur:=p_couleur;
  extremite.setPos(origine.getAbs,origine.getOrd);
end;

destructor TAiguille.Destroy;
// destructeur d'aiguille
begin
  extremite.Free;
	inherited Destroy;
end;

// ----------------------METHODES DE THorloge----------------------------------------------------

procedure THorloge.init;
// initialisation:au dbut
begin
  temps.OnTimer:=tempsTimer;
		// cette affectation pose pb si elle est faite dans le constructeur
  centre.setPos(Width div 2,Height div 2);
  rayon:=(Min(Height,Width) div 2)-1;
  canvas.Font.Color:=FcouleurTrait;
  canvas.Brush.Color:=FcouleurFond;
// calcul de la taille de l'horloge (3:grande, 2:moyenne ou 1:petite)
// l'aspect de l'horloge varie en fonction de cette information
	if rayon > 60 then
  	begin
    	taille:=3;
			affDate.setPos(Trunc((centre.getAbs) - 29),Trunc(centre.getOrd*3/2 - 13));
  		heure.init(centre,Trunc(rayon*0.6),3,FcouleurTrait);
  		minute.init(centre,Trunc(rayon*0.75),2,FcouleurTrait);
    end
	else
  	begin
    	heure.init(centre,Trunc(rayon*0.6),1,FcouleurTrait);
      minute.init(centre,Trunc(rayon*0.75),1,FcouleurTrait);
  		if rayon > 35 then
      	taille:=2
      else
      	taille:=1;
    end;
  seconde.init(centre,Trunc(rayon*0.9),1,FcouleurTrait);
end;

procedure THorloge.dessinerCadran;
// dessin du cadran + ou - dtaill selon la taille de l'horloge
var	pos:integer;
		p : TPointPolaire;
begin
	p:=TPointPolaire.Create;
	canvas.Pen.Width:=1;
  canvas.Pen.Color:=FCouleurTrait;
	canvas.Ellipse(0,0,Width,Height);
	if taille=3 then
    begin
      for pos:=0 to 59 do begin
        p.setPosPolaireCentre(rayon-2,pos*pi/30,centre);
        canvas.Ellipse(p.getAbs-1,p.getOrd-1,p.getAbs+1,p.getOrd+1);
      end;
      for pos:=0 to 11 do begin
          p.setPosPolaireCentre(rayon-3,pos*pi/6,centre);
          canvas.Ellipse(p.getAbs-2,p.getOrd-2,p.getAbs+2,p.getOrd+2);
      end;
    end
  else
     if taille=2 then
	      for pos:=0 to 11 do begin
  	        p.setPosPolaireCentre(rayon-2,pos*pi/6,centre);
    	      canvas.Ellipse(p.getAbs-1,p.getOrd-1,p.getAbs+1,p.getOrd+1);
      	end;
  p.Destroy;
end;

procedure THorloge.setCouleurTrait(p_couleur:TColor);
// changement de couleur de trait, invalidate provoque le raffichage
begin
	FcouleurTrait:=p_couleur;
  invalidate;
end;

procedure THorloge.setCouleurFond(p_couleur:TColor);
// changement de couleur de fond, invalidate provoque le raffichage
begin
	FcouleurFond:=p_couleur;
  invalidate;
end;

procedure THorloge.alarmeDefaut;
begin
	ShowMessage(libelleAlarme);
end;

function THorloge.getLibelle:string;
begin
	getLibelle:=libelleAlarme;
end;

procedure THorloge.tempsTimer(sender : TObject);
// chaque seconde:positionnement des aiguilles
var moment:TDateTime;
		h,m,s : double;
		jour:string;
begin
	getMoment(moment,jour,h,m,s);
	seconde.setPosition(s);
  minute.setPosition(m);
  heure.setPosition(h);
  if taille=3 then
  	canvas.TextOut(affDate.getAbs,affDate.getOrd,jour);
  if alarme then
  	begin
			if moment>=momentAlarme then
      	begin
          alarme:=false;
					if Assigned(OnAlarme) then
          	begin
            	OnAlarme;
              invalidate;
            end;
        end;
    end;
end;

procedure THorloge.getMoment(var moment:TDateTime;var jour:string;var h,m,s:double);
// moment:date et heure systmes, jour:date formate, h,m,s:position des aiguilles (de 0  60)
var jj,mm,aa:integer;
begin
	moment:=Now;
  jj:=DayOf(moment);
  mm:=MonthOf(moment);
  aa:=YearOf(moment);
  jour:=format('%2d/%2d/%4d',[jj,mm,aa]);
	s:=SecondOf(moment);
	m:=MinuteOf(moment)+ (s/60);
  h:=((HourOf(moment) mod 12)+(m/60)) * 5;
end;

procedure THorloge.horlogeDblClick(sender : TObject);
// gestion du double-clic:paramtrage de l'alarme
begin
	if dialogue.ShowModal=mrOk then
  	begin
      momentAlarme:=dialogue.dtp_date.DateTime;
      libelleAlarme:=dialogue.ed_libelle.Text;
      alarme:=true;
    end;
  invalidate;
end;

constructor THorloge.Create(AOwner:TComponent);
// constructeur redfini. Les initialisation fixent l'aspect du composant au dbut de la conception
begin
	inherited Create(AOwner);
	Width:=100;
	Height:=100;
  couleurTrait:=clblue;
  couleurFond:=clyellow;
  temps:=TTimer.Create(self);
  centre:=TPoint.Create;
  heure:=TAiguille.Create(canvas);
  minute:=TAiguille.Create(canvas);
  seconde:=TAiguille.Create(canvas);
  affDate:=TPoint.Create;
	dialogue:=Tfm_dialogue.Create(self);
  alarme:=false;
  OnDblClick:=horlogeDblClick;
  OnAlarme:=alarmeDefaut;
end;

procedure THorloge.Paint;
// appele automatiquement par le systme en cas de raffichage du composant
// les aiguilles seront dessines  la seconde suivant le raffichage (voir tempsTimer)
begin
	init;
	dessinerCadran;
end;

destructor THorloge.Destroy;
// destructeur d'horloge
begin
  dialogue.Free;
	centre.Free;
  heure.Free;
  minute.Free;
  seconde.Free;
  temps.Free;
	inherited Destroy;
end;

end.
